/*
 * regtoolConfig.c
 *
 * Copyright (C) 2006  Joshua Hoblitt
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * program; see the file COPYING. If not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <psmodules.h>
#include <math.h>

#include "pxtools.h"
#include "regtool.h"

pxConfig *regtoolConfig(pxConfig *config, int argc, char **argv)
{
    if (!config) {
        config = pxConfigAlloc();
    }

    pmConfigReadParamsSet(false);

    // setup site config
    config->modules = pmConfigRead(&argc, argv, NULL);
    if (!config->modules) {
        psError(PXTOOLS_ERR_CONFIG, false, "Can't find site configuration");
        psFree(config);
        return NULL;
    }

    // -pendingimfile
    psMetadata *pendingimfileArgs = psMetadataAlloc();
    psMetadataAddStr(pendingimfileArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "search by exposure ID", NULL);
    psMetadataAddStr(pendingimfileArgs, PS_LIST_TAIL, "-class",  0,
        "search by class", NULL);
    psMetadataAddStr(pendingimfileArgs, PS_LIST_TAIL, "-class_id",  0,
        "search by class ID", NULL);
    psMetadataAddU64(pendingimfileArgs, PS_LIST_TAIL, "-limit",  0,
        "limit result set to N items", 0);
    psMetadataAddBool(pendingimfileArgs, PS_LIST_TAIL, "-simple",  0,
        "use the simple output format", false);

    // -addprocessedimfile
    psMetadata *addprocessedimfileArgs = psMetadataAlloc();
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "define exposure ID", NULL);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-class_id",  0,
        "define class ID", NULL);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-exp_type",  0,
        "define exposure type", NULL);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-filelevel",  0,
        "define filelevel", NULL);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-filter",  0,
        "define filter ", NULL);
    psMetadataAddF32(addprocessedimfileArgs, PS_LIST_TAIL, "-airmass",  0,
        "define airmass", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-ra",  0,
        "define RA", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-decl",  0,
        "define DEC", NAN);
    psMetadataAddF32(addprocessedimfileArgs, PS_LIST_TAIL, "-exp_time",  0,
        "define exposure time", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-bg",  0,
        "define exposue background", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-bg_stdev",  0,
        "define exposue background stdev", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-bg_mean_stdev",  0,
        "define exposue background mean stdev", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-alt",  0,
        "define altitute", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-az",  0,
        "define azimuth", NAN);
    psMetadataAddF32(addprocessedimfileArgs, PS_LIST_TAIL, "-ccd_temp",  0,
        "define ccd tempature", NAN);
    psMetadataAddF64(addprocessedimfileArgs, PS_LIST_TAIL, "-posang",  0,
        "define rotator position angle", NAN);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-object",  0,
        "define exposure object", NULL);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-dateobs",  0,
        "define observation time", NULL);
    psMetadataAddS8(addprocessedimfileArgs, PS_LIST_TAIL, "-code",  0,
        "set fault code (required)", 0);

    // -processedimfile
    psMetadata *processedimfileArgs = psMetadataAlloc();
    psMetadataAddStr(processedimfileArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "search by exposure ID", NULL);
    psMetadataAddStr(processedimfileArgs, PS_LIST_TAIL, "-class_id",  0,
        "search by class ID", NULL);
    psMetadataAddU64(processedimfileArgs, PS_LIST_TAIL, "-limit",  0,
        "limit result set to N items", 0);
    psMetadataAddBool(processedimfileArgs, PS_LIST_TAIL, "-faulted",  0,
        "only return imfiles with a fault status set", false);
    psMetadataAddBool(processedimfileArgs, PS_LIST_TAIL, "-simple",  0,
        "use the simple output format", false);

    // -updateprocessedimfile
    psMetadata *updateprocessedimfileArgs = psMetadataAlloc();
    psMetadataAddStr(updateprocessedimfileArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "search by exposure ID", NULL);
    psMetadataAddStr(updateprocessedimfileArgs, PS_LIST_TAIL, "-class_id",  0,
        "search by class ID", NULL);
    psMetadataAddS8(updateprocessedimfileArgs, PS_LIST_TAIL, "-code",  0,
        "set fault code (required)", 0);
    

    // -pendingexp
    psMetadata *pendingexpArgs = psMetadataAlloc();
    psMetadataAddStr(pendingexpArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "search by exposure ID", NULL);
    psMetadataAddStr(pendingexpArgs, PS_LIST_TAIL, "-inst",  0,
        "search by camera", NULL);
    psMetadataAddStr(pendingexpArgs, PS_LIST_TAIL, "-telescope",  0,
        "search by telescope", NULL);
    psMetadataAddStr(pendingexpArgs, PS_LIST_TAIL, "-exp_type",  0,
        "search by exposure type", NULL);
    psMetadataAddStr(pendingexpArgs, PS_LIST_TAIL, "-imfiles",  0,
        "search for exps with N imfiles", NULL);
    psMetadataAddU64(pendingexpArgs, PS_LIST_TAIL, "-limit",  0,
        "limit result set to N items", 0);
    psMetadataAddBool(pendingexpArgs, PS_LIST_TAIL, "-simple",  0,
        "use the simple output format", false);

    // -addprocessedexp
    psMetadata *addprocessedexpArgs = psMetadataAlloc();
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "exp_tag to operate on (required)", NULL); 
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-exp_type",  0,
        "define exposure type", NULL);
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-filelevel",  0,
        "define the data partitioning level of this file", NULL);
    psMetadataAddStr(addprocessedimfileArgs, PS_LIST_TAIL, "-workdir",  0,
        "define the \"default\" workdir for this exposure", NULL);
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-filter",  0,
        "define filter ", NULL);
    psMetadataAddF32(addprocessedexpArgs, PS_LIST_TAIL, "-airmass",  0,
        "define airmass", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-ra",  0,
        "define RA", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-decl",  0,
        "define DEC", NAN);
    psMetadataAddF32(addprocessedexpArgs, PS_LIST_TAIL, "-exp_time",  0,
        "define exposure time", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-bg",  0,
        "define exposue background", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-bg_stdev",  0,
        "define exposue background stdev", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-bg_mean_stdev",  0,
        "define exposue background mean stdev", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-alt",  0,
        "define altitute", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-az",  0,
        "define azimuth", NAN);
    psMetadataAddF32(addprocessedexpArgs, PS_LIST_TAIL, "-ccd_temp",  0,
        "define ccd tempature", NAN);
    psMetadataAddF64(addprocessedexpArgs, PS_LIST_TAIL, "-posang",  0,
        "define rotator position angle", NAN);
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-object",  0,
        "define exposure object", NULL);
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-dateobs",  0,
        "define observation time", NULL);
    psMetadataAddStr(addprocessedexpArgs, PS_LIST_TAIL, "-label",  0,
        "define label for phase 2 processing (non-detrend data only)", NULL);
    psMetadataAddS8(addprocessedexpArgs, PS_LIST_TAIL, "-code",  0,
        "set fault code (required)", 0);
    /*
    psMetadataAddStr(updateArgs, PS_LIST_TAIL, "-recip",  0,
        "define URL", NULL);
    psMetadataAddStr(updateArgs, PS_LIST_TAIL, "-mosiac",  0,
        "define URL", NULL);
    */
    psMetadataAddBool(addprocessedexpArgs, PS_LIST_TAIL, "-detrend",  0,
        "declare this as detrend data", false);

    // -processedexp
    psMetadata *processedexpArgs = psMetadataAlloc();
    psMetadataAddStr(processedexpArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "search by exposure ID", NULL);
    psMetadataAddU64(processedexpArgs, PS_LIST_TAIL, "-limit",  0,
        "limit result set to N items", 0);
    psMetadataAddBool(processedexpArgs, PS_LIST_TAIL, "-faulted",  0,
        "only return imfiles with a fault status set", false);
    psMetadataAddBool(processedexpArgs, PS_LIST_TAIL, "-simple",  0,
        "use the simple output format", false);

    // -updatedprocessedexp
    psMetadata *updatedprocessedexpArgs = psMetadataAlloc();
    psMetadataAddStr(updatedprocessedexpArgs, PS_LIST_TAIL, "-exp_tag",  0,
        "search by exposure ID", NULL);
    psMetadataAddS8(updatedprocessedexpArgs, PS_LIST_TAIL, "-code",  0,
        "set fault code (required)", 0);
    

#define PXTOOL_MODE(option, modeval, argset) \
{ \
    int N = 0; \
    if ((N = psArgumentGet (argc, argv, option))) { \
        psArgumentRemove (N, &argc, argv); \
        if (config->mode) { \
            psError(PXTOOLS_ERR_CONFIG, true, "only one mode selection is allowed"); \
            psFree(config); \
            return NULL; \
        } \
        config->mode = modeval; \
        config->args = psMemIncrRefCounter(argset); \
    } \
    if (!psMetadataAddMetadata(argSets, PS_LIST_TAIL, option, 0, NULL, argset)) {;\
        psError(PXTOOLS_ERR_PROG, false, "failed to add argset for %s", option);\
    } \
    psFree(argset); \
}

    psMetadata *argSets = psMetadataAlloc();
    // find which mode we're running under
    PXTOOL_MODE("-pendingimfile",   REGTOOL_MODE_PENDINGIMFILE, pendingimfileArgs);
    PXTOOL_MODE("-addprocessedimfile", REGTOOL_MODE_ADDPROCESSEDIMFILE, addprocessedimfileArgs);
    PXTOOL_MODE("-processedimfile", REGTOOL_MODE_PROCESSEDIMFILE, processedimfileArgs);
    PXTOOL_MODE("-updateprocessedimfile",  REGTOOL_MODE_UPDATEPROCESSEDIMFILE, updateprocessedimfileArgs);
    PXTOOL_MODE("-pendingexp",      REGTOOL_MODE_PENDINGEXP,pendingexpArgs);
    PXTOOL_MODE("-addprocessedexp", REGTOOL_MODE_ADDPROCESSEDEXP, addprocessedexpArgs);
    PXTOOL_MODE("-processedexp",    REGTOOL_MODE_PROCESSEDEXP, processedexpArgs);
    PXTOOL_MODE("-updateprocessedexp", REGTOOL_MODE_UPDATEPROCESSEDEXP,      updatedprocessedexpArgs);

    bool argErr = false;
    if (config->mode == REGTOOL_MODE_NONE) {
	psError(PXTOOLS_ERR_CONFIG, false, "missing mode argument");
        fprintf (stderr, "mode argument is required\n");
        argErr = true;
    } else if (! psArgumentParse(config->args, &argc, argv) || argc != 1) {
	psError(PXTOOLS_ERR_CONFIG, false, "unknown argument");
        fprintf (stderr, "error parsing arguments\n");
        argErr = true;
    }

    if (argErr) {
        printf("\nPan-STARRS Registration Tool\n");
        printf("Usage: %s <mode> [<options>]\n\n", argv[0]);
        printf(" <mode> :\n\n");

        psMetadataIterator *iter = psMetadataIteratorAlloc(argSets, 0, NULL);
        psMetadataItem *item = NULL;
        while ((item = psMetadataGetAndIncrement(iter))) {
            if (!item->type == PS_DATA_METADATA) {
                psAbort("all options must be specified as a metadata");            }

            fprintf(stdout, "%s ", item->name);
            psArgumentHelp(item->data.md);
        }
        psFree(iter);

        psFree(argSets);
        psFree(config);
        return NULL;
    }

    psFree(argSets);

    // setup search criterion
#define addWhereStr(name) \
{ \
    psString str = NULL; \
    bool status = false; \
    if ((str = psMetadataLookupStr(&status, config->args, "-" #name))) { \
        if (!psMetadataAddStr(config->where, PS_LIST_TAIL, #name, 0, "==", str)) {\
            psError(PXTOOLS_ERR_PROG, false, "failed to add item " #name); \
            psFree(config); \
            return NULL; \
        } \
    } \
}

    // generate SQL where clause
    config->where = psMetadataAlloc();

    addWhereStr(exp_tag);
    // convert '-inst' to 'camera'
    {
        psString str = NULL; 
        bool status = false;
        if ((str = psMetadataLookupStr(&status, config->args, "-inst"))) {
            if (!psMetadataAddStr(config->where, PS_LIST_TAIL, "camera", 0, "==", str)) {
                psError(PXTOOLS_ERR_PROG, false, "failed to add item camera");
                psFree(config);
                return NULL;
            }
        }
    }
    addWhereStr(telescope);
    addWhereStr(exp_type);
    {
        int imfiles = 0; 
        bool status = false;
        if ((imfiles = psMetadataLookupS32(&status, config->args, "-imfiles"))) {
            if (!psMetadataAddS32(config->where, PS_LIST_TAIL, "imfiles", 0, "==", imfiles)) {
                psError(PXTOOLS_ERR_PROG, false, "failed to add item imfiles");
                psFree(config);
                return NULL;
            }
        }
    }
    addWhereStr(class);
    addWhereStr(class_id);
    addWhereStr(filter);

    if (config->where->list->n < 1) {
        psFree(config->where);
        config->where = NULL;
    }


    // define Database handle, if used
    config->dbh = pmConfigDB(config->modules);
    if (!config->dbh) {
        psError(PXTOOLS_ERR_SYS, false, "Can't configure database");
        psFree(config);
        return NULL;
    }

    // save argv/argc
    config->argv = argv;
    config->argc = argc;

    return config;
}
